// Apfelteig Patch ;-)

#include "stdafx.h"
#include "emule.h"
#include "PPgHTTPD.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define HIDDEN_PASSWORD _T("*****")

IMPLEMENT_DYNAMIC(CPPgHTTPD, CPropertyPage)
CPPgHTTPD::CPPgHTTPD()
	: CPropertyPage(CPPgHTTPD::IDD)
{
}

CPPgHTTPD::~CPPgHTTPD()
{
}

void CPPgHTTPD::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}
BEGIN_MESSAGE_MAP(CPPgHTTPD, CPropertyPage)
	ON_EN_CHANGE(IDC_HTTPDPASS, OnDataChange)
	ON_EN_CHANGE(IDC_HTTPDPASSLOW, OnDataChange)
	ON_EN_CHANGE(IDC_HTTPDPORT, OnDataChange)
	ON_BN_CLICKED(IDC_HTTPDENABLED, OnEnChangeHTTPDEnabled)
	ON_BN_CLICKED(IDC_HTTPDENABLEDLOW, OnEnChangeHTTPDEnabled)
	ON_BN_CLICKED(IDC_HTTPDRELOADTMPL, OnReloadTemplates)
	ON_BN_CLICKED(IDC_STATIC_GENERAL, OnBnClickedStaticGeneral)
END_MESSAGE_MAP()

BOOL CPPgHTTPD::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	((CEdit*)GetDlgItem(IDC_HTTPDPASS))->SetLimitText(12);
	((CEdit*)GetDlgItem(IDC_HTTPDPASSLOW))->SetLimitText(12);
	((CEdit*)GetDlgItem(IDC_HTTPDPORT))->SetLimitText(6);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgHTTPD::LoadSettings(void)
{
	CString strBuffer;

	GetDlgItem(IDC_HTTPDPASS)->SetWindowText(HIDDEN_PASSWORD);
	GetDlgItem(IDC_HTTPDPASSLOW)->SetWindowText(HIDDEN_PASSWORD);
	strBuffer.Format("%d", app_prefs->GetWSPort());
	GetDlgItem(IDC_HTTPDPORT)->SetWindowText(strBuffer);
	if(app_prefs->GetWSIsEnabled())
		CheckDlgButton(IDC_HTTPDENABLED,1);
	else
		CheckDlgButton(IDC_HTTPDENABLED,0);

	if(app_prefs->GetWSIsLowUserEnabled())
		CheckDlgButton(IDC_HTTPDENABLEDLOW,1);
	else
		CheckDlgButton(IDC_HTTPDENABLEDLOW,0);

	OnEnChangeHTTPDEnabled();

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgHTTPD::OnApply()
{	
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		CString sBuf;
		uint16 oldPort=app_prefs->GetWSPort();

		GetDlgItem(IDC_HTTPDPASS)->GetWindowText(sBuf);
		if(sBuf != HIDDEN_PASSWORD)
			app_prefs->SetWSPass(sBuf);
		GetDlgItem(IDC_HTTPDPASSLOW)->GetWindowText(sBuf);
		if(sBuf != HIDDEN_PASSWORD)
			app_prefs->SetWSLowPass(sBuf);

		GetDlgItem(IDC_HTTPDPORT)->GetWindowText(sBuf);
		if (atoi(sBuf)!=oldPort) {
			app_prefs->SetWSPort(atoi(sBuf));
			theApp.webserver->RestartServer();
		}
		app_prefs->SetWSIsEnabled((int8)IsDlgButtonChecked(IDC_HTTPDENABLED));
		app_prefs->SetWSIsLowUserEnabled((int8)IsDlgButtonChecked(IDC_HTTPDENABLEDLOW));
		theApp.webserver->StartServer();

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgHTTPD::Localize(void)
{
	if(m_hWnd){
		SetWindowText(GetResString(IDS_PW_HTTPD));
		GetDlgItem(IDC_HTTPDPASS_LBL)->SetWindowText(GetResString(IDS_HTTPD_PASS));
		GetDlgItem(IDC_HTTPDPORT_LBL)->SetWindowText(GetResString(IDS_PORT));
		GetDlgItem(IDC_HTTPDENABLED)->SetWindowText(GetResString(IDS_ENABLED));
		GetDlgItem(IDC_HTTPDRELOADTMPL)->SetWindowText(GetResString(IDS_HTTPD_RELOAD_TMPL));

		GetDlgItem(IDC_HTTPDPASS_LBL2)->SetWindowText(GetResString(IDS_HTTPD_PASS));
		GetDlgItem(IDC_HTTPDENABLEDLOW)->SetWindowText(GetResString(IDS_ENABLED));
		GetDlgItem(IDC_STATIC_GENERAL)->SetWindowText(GetResString(IDS_PW_GENERAL));

		GetDlgItem(IDC_STATIC_ADMIN)->SetWindowText(GetResString(IDS_WEB_ADMIN));
		GetDlgItem(IDC_STATIC_LOWUSER)->SetWindowText(GetResString(IDS_WEB_LOWUSER));
		GetDlgItem(IDC_HTTPDENABLEDLOW)->SetWindowText(GetResString(IDS_ENABLED));
	}
}

void CPPgHTTPD::OnEnChangeHTTPDEnabled()
{
	GetDlgItem(IDC_HTTPDPASS)->EnableWindow(IsDlgButtonChecked(IDC_HTTPDENABLED));	
	GetDlgItem(IDC_HTTPDPORT)->EnableWindow(IsDlgButtonChecked(IDC_HTTPDENABLED));	
	GetDlgItem(IDC_HTTPDRELOADTMPL)->EnableWindow(IsDlgButtonChecked(IDC_HTTPDENABLED)); // EC
	GetDlgItem(IDC_HTTPDENABLEDLOW)->EnableWindow(IsDlgButtonChecked(IDC_HTTPDENABLED));
	GetDlgItem(IDC_HTTPDPASSLOW)->EnableWindow(IsDlgButtonChecked(IDC_HTTPDENABLED));

	SetModified();
}

void CPPgHTTPD::OnReloadTemplates()
{
	theApp.webserver->ReloadTemplates();
}

void CPPgHTTPD::OnBnClickedStaticGeneral()
{
	// TODO: Add your control notification handler code here
}
